using System;
using System.Collections;

using DevExpress.XtraEditors;
using DevExpress.XtraPivotGrid;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.enablingCustomSortingCheckEdit.CheckedChanged += enablingCustomSortingCheckEdit_CheckedChanged;
            this.pivotGridControl.CustomFieldSort              += pivotGridControl_CustomFieldSort;

            this.excelDataSource.FileName = "SalesPerson.xlsx";

            this.excelDataSource.Fill();

            this.pivotGridControl.BestFit();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Ŀ  Ȱȭ üũ  üũ  óϱ - enablingCustomSortingCheckEdit_CheckedChanged(sender, e)

        /// <summary>
        /// Ŀ  Ȱȭ üũ  üũ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void enablingCustomSortingCheckEdit_CheckedChanged(object sender, EventArgs e)
        {
            CheckEdit checkEdit = sender as CheckEdit;

            this.salesPersonField.SortMode = checkEdit.Checked ? PivotSortMode.Custom : PivotSortMode.Default;
        }

        #endregion
        #region ǹ ׸ Ʈ ʵ  Ŀ ϱ - pivotGridControl_CustomFieldSort(sender, e)

        /// <summary>
        /// ǹ ׸ Ʈ ʵ  Ŀ ϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pivotGridControl_CustomFieldSort(object sender, PivotGridCustomFieldSortEventArgs e)
        {
            if(e.Field.FieldName == "Sales Person")
            {
                if(e.SortLocation == PivotSortLocation.Pivot)
                {
                    object orderValue1 = e.GetListSourceColumnValue(e.ListSourceRowIndex1, "Last Name");
                    object orderValue2 = e.GetListSourceColumnValue(e.ListSourceRowIndex2, "Last Name");

                    e.Result = Comparer.Default.Compare(orderValue1, orderValue2);
                }
                else
                {
                    e.Result = Comparer.Default.Compare(e.Value1.ToString().Split(' ')[1], e.Value2.ToString().Split(' ')[1]);
                }

                e.Handled = true;
            }
        }

        #endregion
    }
}